#include "math.h"
#include <caml/memory.h>
#include <caml/mlvalues.h>
#include <caml/callback.h>
#include <caml/alloc.h>

void hjtg(int v)
{
	static value *kidlgz = 0;
	if (!kidlgz) kidlgz = caml_named_value("iterate_fun");
	if (!kidlgz) return;
	callback(*kidlgz, Val_int(v));
}

void ugys()
{
	static value * felvnl = 0;
	if (!felvnl) felvnl = caml_named_value("cleanup_fun");
	if (!felvnl) return;

	callback(*felvnl, Val_int(0));
}

void osszb(int pos, double x, double y, double w, double h)
{
	CAMLparam0();

	static value * fldlgz = 0;
	if (!fldlgz) fldlgz = caml_named_value("add_box_fun");

	CAMLlocalN(va, 5);

	va[0] = Val_int(pos);
	va[1] = copy_double(x);
	va[2] = copy_double(y);
	va[3] = copy_double(w);
	va[4] = copy_double(h);

	callbackN(*fldlgz, 5, va);

	CAMLreturn0;
}

void osszd(int x, int y)
{
	static value * bprl = 0;
	if (!bprl) bprl = caml_named_value("add_cstr_fun");
	callback2(*bprl, Val_int(x), Val_int(y));
}

double ivdx(int pos)
{
	static value * prmz = 0;
	if (!prmz) prmz = caml_named_value("get_x_fun");
	double d = Double_val(callback(*prmz, Val_int(pos)));
	if (isnan(d)) d=0.;
	if (d>55000.||d<-55000.) d=0.;
	return d;
}

double ivdy(int pos)
{
	static value * mrtdt = 0;
	if (!mrtdt) mrtdt = caml_named_value("get_y_fun");
	double d = (Double_val(callback(*mrtdt, Val_int(pos))));
	if (isnan(d)) d=0.;
	if (d>55000.||d<-55000.) d=0.;
	return d;
}


void dolog(int ax1, int ax2, int ay1, int ay2, int ap,
	int bx1, int bx2, int by1, int by2, int bp)
{
	CAMLparam0();

	static value * kitzjl = 0;
	if (!kitzjl) kitzjl = caml_named_value("set_rects_fun");

	CAMLlocalN(va, 10);

	va[0] = Val_int(ax1);
	va[1] = Val_int(ax2);
	va[2] = Val_int(ay1);
	va[3] = Val_int(ay2);
	va[4] = Val_int(ap);
	va[5] = Val_int(bx1);
	va[6] = Val_int(bx2);
	va[7] = Val_int(by1);
	va[8] = Val_int(by2);
	va[9] = Val_int(bp);

	callbackN(*kitzjl, 10, va);

	CAMLreturn0;
}

int cel(int pos)
{
	static value * jlzpnt = 0;
	if (!jlzpnt) jlzpnt = caml_named_value("get_vx_fun");
	int d = Int_val(callback(*jlzpnt, Val_int(pos)));
	if (isnan(d)) d=0.;
	if (d>55000.||d<-55000.) d=0.;
	return d;
}

int klsirz(int pos)
{
	static value * irnyjl = 0;
	if (!irnyjl) irnyjl = caml_named_value("get_vy_fun");
	int d = Int_val(callback(*irnyjl, Val_int(pos)));
	if (isnan(d)) d=0.;
	if (d>55000.||d<-55000.) d=0.;
	return d;
}

int nmsg()
{
	static value * adelk = 0;
	if (!adelk) adelk = caml_named_value("num_seg_fun");
	return Int_val(callback(*adelk, Val_int(0)));
}

